Description

It would be nice to have an emptyOption as attribute for the f:form.select view helper.

So you could write

<f:form.select property="category" options="{categories}" 
optionLabelField="name" size="1" id="category" emptyOption="- none -" />

and generate:
<select name="category" size="1" id="category">
<option value="">- none -</option>
<option value="cat1">cat1</option>
<option value="cat2">cat2</option>
<option value="cat3">cat3</option>
</select>

I implemented it with adding in selectViewHelper lines 210 ff (FLOW3 a7 version) these lines:
        if ($this->arguments->hasArgument('emptyOption')) {
            $options = array('' => $this->arguments['emptyOption']) + $options;
        }

and registering it in the initializeArguments method:
$this->registerArgument('emptyOption', 'string', 'If specified, an empty option will be added with the given string as label.');

I can't currently provide a real patch, as I have no svn version here, sorry :(

History
#1 - 2010-02-01 17:40 - Susanne Moog

I should have additionally mentioned that the code above just gives the possibility to add the empty option. You will most likely get an error if you try to
save it, so the saving part is still missing.

#2 - 2010-04-01 11:12 - Peter Niederlag

adding an Idea from Jochen: 

strip "semantics" off the argument. Two options "appendOption" and "prependOption" seems to be cleaner.
This feature is quite often needed in reallife IMO.

#3 - 2010-07-12 12:45 - Bastian Waidelich
- Project changed from TYPO3.Fluid to Fluid - ViewHelper - Incubator
- Category deleted (ViewHelpers)

#4 - 2010-07-12 13:44 - Bastian Waidelich
- Subject changed from Possibility to add an emptyOption to the f:form.select view helper to form.select: Possibility to add an emptyOption

#5 - 2010-10-26 11:49 - Henjo Hoeksma
- File emptyOption.diff added

attached a patch that provides a solution Susanne considered. It provides an argument 'prependOption'. The value of the argument is the label of the
valueless option tag.

#6 - 2011-05-17 12:34 - Alex Kellner

+1

Thx, sounds like a nice hack, but only a hack at the moment :(

#7 - 2011-07-25 19:58 - Bastian Waidelich
- Tracker changed from Feature to Suggestion

#8 - 2011-10-13 15:25 - Thomas Löffler

+1!

What's the status of this issue? Any problems? Or any dissonances?

#9 - 2011-11-21 11:42 - Grummfy 

on typo3 4.5.4, to save it correctly I need to replace
$options = array('' => $this->arguments['emptyOption']) + $options;
by this
$options = array('-1' => $this->arguments['emptyOption']) + $options;

And it works

#10 - 2012-04-27 04:58 - Dominic Garms

Hello,

I would love to see this feature merged into fluid, because this is very often required in search form fields. +1

#11 - 2012-10-09 09:04 - Pascal Dürsteler
+1, I count this as a basic requirement.

Personally, I'd do it like this:
includeBlank="--- Choose ---"

which gives you the possibility to either include a blank one with no text or a defined text/translation.

Jochen's idea posted by Peter Niederlag seems nice, however I don't see the benefit of adding something at the end of a select. If you have to add
something, that would be at the top.

#12 - 2012-10-09 09:55 - Pascal Dürsteler
- File issue_6301.diff added

Adding diff which introduces
includeBlank="<label>"

to the select view helper. Also introduces a little change to the extbase mapper to treat '' values as NULL values which already is in the code, but not
for numeric/arrays, which is required here. This also prevents the discussed error above.

#13 - 2013-02-27 17:14 - Pascal Dürsteler

Looks like this can be closed because of http://forge.typo3.org/issues/26595

#14 - 2013-02-27 17:35 - Bastian Waidelich
- Status changed from New to Closed
- Has patch set to No

Pascal Dürsteler wrote:

Looks like this can be closed because of http://forge.typo3.org/issues/26595

Right. Although this still needs to be "forward ported" to Flow

Files
emptyOption.diff 1.6 kB 2010-10-26 Henjo Hoeksma
issue_6301.diff 2.1 kB 2012-10-09 Pascal Dürsteler
